/*
  Java Japanese-English dictionary/Kanjidic browser
  Copyright (C) 1997 Todd David Rudick

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

 */

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import ButtonList;
import JavaDict;
import GUI;
import GenList;

public class KanjiViewer extends Panel implements 
ButtonList.ButtonListListener,ItemListener,GenList {
  JavaDict javadict;
  Font BigFont;
  Font BiggerFont;
  String dict;
  String dictindex;
  char currentKanji = 0;

  static public class ButtonHits implements ActionListener {
    int mybut;
    KanjiViewer paps;

    public ButtonHits(int butnum, KanjiViewer paps) {
      mybut = butnum;
      this.paps=paps;
    }
    public void actionPerformed(ActionEvent e) {
      switch (mybut) {
	/*      case 1: // RETURN BUTTON
		paps.card.show(paps.parent,paps.returncardname);
		paps.javadict.
		break;*/
      case 2:
	java.lang.Thread t; // SEARCH BUTTON
	//	String thekanji;
	//	thekanji = paps.thekanjiC.getSelectedItem();
	t = new java.lang.Thread(JavaDict.LookUp.lookupgroup,
				 new 
				 JavaDict.LookUp(paps.currentKanji+"",
						 paps.javadict.gui.OutputArea,
						 paps.javadict.gui.dict,
						 paps.javadict.gui.dictindex,
						 true));
				 
	t.setDaemon(true); // exit if it's the only thing running
	t.setPriority(java.lang.Thread.MIN_PRIORITY);
	t.start();
	paps.javadict.todictionary.doaction();
	//	paps.card.show(paps.parent,paps.returncardname);
      }
    }
  }

  // sub-components
  //  CardLayout thekanjiCL = new CardLayout();
  Panel thekanjiP = null;
  //new Panel();
  Choice thekanjiC = null;
  Label thekanjiL = null;
  Panel innertop;
  Panel OnReadings; // Katakana
  Panel KunReadings; // Hiragana
  Panel English; // between { and }
  Label Bushu = new Label("Bushu: 452"); // B#
  Label Frequency = new Label("Freq: 3204"); // F#
  Label Grade = new Label("Grade: 41"); // G#
  Label Halpern = new Label("Halpern: 3058"); // H#
  Label Nelson = new Label("Nelson: 1023"); // N#
  Label SkipCode = new Label("Skip: 1-3-4"); // P#-#-#
  Label Strokes = new Label("Strokes: 71"); // S#
  Label FourCorn = new Label("4-Corner: 1332.0"); // Q#.#
  Label MoroHashiN = new Label("2313X"); // MN#? = index number (DaiKanWaJiten)
  Label MoroHashiP = new Label("23.12"); // MP#.#   = vol, page (DaiKanWaJiten)
  Color fg,bg;

  public KanjiViewer(JavaDict javadict, Button ReturnButton,
		     String dict, String dictindex) {
    super();
    this.BigFont = javadict.BigFont;
    this.BiggerFont =javadict.BiggerFont;
    this.dict = dict;
    this.dictindex = dictindex;

    this.javadict=javadict;
    // do the "Back" button thingy
    this.setLayout(new BorderLayout(0,0));
    Panel ButtonPanel = new Panel(new BorderLayout(0,0));
    add(ButtonPanel,"South");

    //    Button ReturnButton = new Button("Return");
    ButtonPanel.add(ReturnButton,"East");
    //    ReturnButton.addActionListener(new ButtonHits(1,this));

    Button LookupButton = new Button("Find in Dictionary");
    ButtonPanel.add(LookupButton,"West");
    LookupButton.addActionListener(new ButtonHits(2,this));
    
    ScrollPane inners = new ScrollPane();
    add(inners,"Center");

    Panel inner = new Panel(new BorderLayout(0,0));
    inners.add(inner,"Center");
    
    // Divide into top and bottom
    innertop = new Panel(new BorderLayout(0,0));
    inner.add(innertop,"North");
    Panel innerbottom = new Panel(new GridLayout(3,1,0,0));
    inner.add(innerbottom,"South");

    // divide top into left & right
    // Make the big kanji label
    //    thekanjiC.add(GUI.HModeLabel);
    //    thekanjiC.setFont(BiggerFont);
    //    thekanjiC.doLayout();
    //    thekanjiC.addItemListener(this);
    //    thekanjiL.setFont(BiggerFont);
    

    /*    fg = thekanji.getBackground(); // reverse video
	  bg = thekanji.getForeground();
	  thekanji.setBackground(bg);
	  thekanji.setForeground(fg);
	  */
    //    thekanjiP.setLayout(thekanjiCL);
    //    thekanjiP.setLayout(new BorderLayout());
    //    thekanjiP.add(thekanjiC,"Choice");
    //    thekanjiP.add(thekanjiL,"Label");
    //    thekanjiCL.show(thekanjiP,"Label");
    //    thekanjiCL.show(thekanjiP,"Choice");
    //    thekanjiP.add(thekanjiC,"North");
    //    thekanjiP.add(thekanjiL,"Center");

    //    innertop.add(thekanjiP,"West");
    Panel innertopright = new Panel(new BorderLayout(0,0));
				    /*new GridLayout(3,1,0,0)*/
    innertop.add(innertopright,"Center");
    English = new Panel(new FlowLayout(FlowLayout.LEFT));
    OnReadings = new Panel(new FlowLayout(FlowLayout.LEFT));
    KunReadings = new Panel(new FlowLayout(FlowLayout.LEFT));
    innertopright.add(English,"North");
    Panel KanaReadings = new Panel(new BorderLayout(0,0));
    innertopright.add(KanaReadings,"Center");
    /*    innertopright.add(OnReadings,"Center");
	  innertopright.add(KunReadings,"South");*/
    KanaReadings.add(OnReadings,"North");
    KanaReadings.add(KunReadings,"Center");
    // so the sizes are right, add labels
    English.add(new Label("Meanings: "));
    OnReadings.add(new Label("On Readings: "));
    KunReadings.add(new Label("Kun Readings: "));

    // set up all the labels in the lower panel
    Panel innerbottom1 = new Panel(new FlowLayout(FlowLayout.LEFT));
    Panel innerbottom2 = new Panel(new FlowLayout(FlowLayout.LEFT));
    Panel innerbottom3 = new Panel(new FlowLayout(FlowLayout.LEFT));
    innerbottom.add(innerbottom1);
    innerbottom.add(innerbottom2);
    innerbottom.add(innerbottom3);
    innerbottom1.add(Bushu);
    innerbottom1.add(Frequency);
    innerbottom1.add(Grade);
    innerbottom2.add(Strokes);
    innerbottom2.add(Nelson);
    innerbottom2.add(FourCorn);
    innerbottom3.add(Halpern);
    innerbottom3.add(SkipCode);
  }

  public void itemStateChanged(ItemEvent e) {
    currentKanji = thekanjiC.getSelectedItem().charAt(0);
    searchKanji();
  }

  void searchKanji() {
    String s;
    s = "U"+Integer.toHexString(currentKanji)+" ";
    java.lang.Thread t;
    //    System.out.println("Perform search for: "+s);
    t = new java.lang.Thread(JavaDict.LookUp.lookupgroup,
			     new JavaDict.LookUp(s, this,
						 dict, dictindex,false));
			     
    t.setDaemon(true); // exit if it's the only thing running
    t.setPriority(java.lang.Thread.MIN_PRIORITY);
    
    t.start();
  }

  void clearKanji() {
    if (thekanjiL!=null) { 
      innertop.remove(thekanjiL);
      thekanjiL=null;
    } else 
      if (thekanjiC!=null) {
	innertop.remove(thekanjiC);
	thekanjiC=null;
      }
  }

  public void ViewArray(char[] c) {
    clearKanji();
    currentKanji = c[0];
    if (c.length==1) {
      thekanjiL = new Label(c[0]+"");
      thekanjiL.setFont(BiggerFont);
      innertop.add(thekanjiL,"West");
      thekanjiL.invalidate();
      validate();
    } else {
      thekanjiC = new Choice();
      int i;
      for (i=0;i<c.length;i++)
	thekanjiC.add(c[i]+"");
      thekanjiC.setFont(BiggerFont);
      thekanjiC.addItemListener(this);
      innertop.add(thekanjiC,"West");
      thekanjiC.invalidate();
      validate();
    }
    searchKanji();
  }

  public void add(String s) {
    //    System.out.println(s);
    View(s);
  }

  public void ActionText(String s) {
    clearKanji();
    currentKanji = s.charAt(0);
    thekanjiL = new Label(currentKanji+"");
    thekanjiL.setFont(BiggerFont);
    innertop.add(thekanjiL,"West");
    thekanjiL.invalidate();
    validate();
    View(s);
    javadict.tokanjiviewer.doaction();
  }

  public void removeAll() {
    Bushu.setText("Bushu "); // B#
    Frequency.setText("Freq "); // F#
    Grade.setText("Grade "); // G#
    Halpern.setText("Halpern "); // H#
    Nelson.setText("Nelson "); // N#
    SkipCode.setText("Skip "); // P#-#-#
    Strokes.setText("Strokes "); // S#
    FourCorn.setText("4-Corner "); // Q#.#
    English.removeAll();
    English.add(new Label("Meanings:"));
    OnReadings.removeAll();
    OnReadings.add(new Label("On Readings:"));
    KunReadings.removeAll();
    KunReadings.add(new Label("Kun Readings:"));
  }

  public void View(String s) {
    Bushu.setText("Bushu "); // B#
    Frequency.setText("Freq "); // F#
    Grade.setText("Grade "); // G#
    Halpern.setText("Halpern "); // H#
    Nelson.setText("Nelson "); // N#
    SkipCode.setText("Skip "); // P#-#-#
    Strokes.setText("Strokes "); // S#
    FourCorn.setText("4-Corner "); // Q#.#
    English.removeAll();
    English.add(new Label("Meanings:"));
    OnReadings.removeAll();
    OnReadings.add(new Label("On Readings:"));
    KunReadings.removeAll();
    KunReadings.add(new Label("Kun Readings:"));

    int index;
    s = s.substring(7); // skip the hex code
  parseloop: 
    while (true) {
      s=s.trim();
      if (s.length()==0) break;
      index = s.indexOf(" ");
      if (index==-1) index=s.length();
      String cur;
      cur = s.substring(0,index).trim();
      if (cur.length()==0) break;
      //System.out.println("Cur = " + cur);
      String cur2 = cur.substring(1);
      switch (cur.charAt(0)) {
      case 'B': Bushu.setText(Bushu.getText()+cur2+" "); break;
      case 'F': Frequency.setText(Frequency.getText()+cur2+" "); break;
      case 'G': Grade.setText(Grade.getText()+cur2+" "); break;
      case 'H': Halpern.setText(Halpern.getText()+cur2+" "); break;
      case 'N': Nelson.setText(Nelson.getText()+cur2+" "); break;
      case 'P': SkipCode.setText(SkipCode.getText()+cur2+" "); break;
      case 'S': Strokes.setText(Strokes.getText()+cur2+" "); break;
      case 'Q': FourCorn.setText(FourCorn.getText()+cur2+" "); break;
      case '-': // Kana Prefix 
	Panel p2 = getcorrectpanel(cur2.charAt(0)); 
	Label l2 = new Label();
	if (p2!=English) l2.setFont(BigFont);
	l2.setText(convertReading(cur)+";");
	p2.add(l2);
	break;
      case '{': // English
	index = s.indexOf("}");
	if (index==-1) {
	  System.out.println("Malformed kanjidic entry");
	  break parseloop;
	} else {
	  English.add(new Label(s.substring(1,index)+";"));
	  break;
	}
      default: // may be kana
	Panel p = getcorrectpanel(cur.charAt(0));
	if (p!=English) { // we have kana!
	  Label l = new Label();
	  l.setFont(BigFont);
	  l.setText(convertReading(cur)+";");
	  p.add(l);
	}
      }
      s = s.substring(index);
    }
    //    card.show(parent,mycardname);
    //    javadict.tokanjiviewer.doaction();
    this.validateTree();
    doLayout();
  }

  String convertReading(String r) {
    int i;
    i = r.indexOf('.');
    if (i==-1) return(r); else {
      String s;
      s = r.substring(0,i)+"("+r.substring(i+1)+")";
      return(s);
    }
  }
  
  Panel getcorrectpanel(char c) { // determine panel for on,kun, or english
    if (c<'\u3000') return(English);
    else if (c<'\u30a0') return(KunReadings);
    else return(OnReadings);
  }
}
